
# cpu util:		mpstat 1 1
# load average:	/proc/loadavg
# running dump
# D state dump
# sirq analysis

get_running() {
	echo "running load:" >> $tmpfile
	for pid in `ls /proc`
	do
		if [ "$pid" -gt 0 ] 2>/dev/null; then
			for tid in `ls /proc/${pid}/task/ 2>/dev/null`
			do
				if [ "$tid" -gt 0 ] 2>/dev/null; then
					run=`cat /proc/$tid/status | grep "running" | wc -l`
					if [ "$run" -gt 0 ] 2>/dev/null; then
						echo $tid >> $tmpfile
						task_name="`cat /proc/$tid/status | grep Name`"
						echo $task_name >> $tmpfile
						running_tasks=$(($running_tasks+1))
					fi
				fi
			done
		fi
	done
}

get_disk_sleep() {
	echo "D state load:" >> $tmpfile
	for pid in `ls /proc`
	do
		if [ "$pid" -gt 0 ] 2>/dev/null; then
			for tid in `ls /proc/${pid}/task/ 2>/dev/null`
			do
				if [ "$tid" -gt 0 ] 2>/dev/null; then
					dsleep=`cat /proc/$tid/status | grep "disk sleep" | wc -l`
					if [ "$dsleep" -gt 0 ] 2>/dev/null; then
						echo $tid >> $tmpfile
						task_name="`cat /proc/$tid/status | grep Name`"
						echo $task_name >> $tmpfile
						cat /proc/${tid}/stack >> $tmpfile
						dsleep_tasks=$(($dsleep_tasks+1))
					fi
				fi
			done
		fi
	done
}

record_current_load() {
	local proc_load=`cat /proc/loadavg`
	echo "####################################################################################" > $tmpfile
	echo "Time: `date "+%Y-%m-%d %H:%M:%S"`" >> $tmpfile
	echo "Load average: $proc_load" >> $tmpfile

	echo >> $tmpfile
	get_running
	echo >> $tmpfile
	get_disk_sleep
	cpu_util=(`mpstat $interval 1 | awk 'END {print $3" "$5" "$6" "$7" "$8" "$12}'`)
	usr_util=${cpu_util[0]}
	sys_util=${cpu_util[1]}
	io_wait=${cpu_util[2]}
	irq_util=${cpu_util[3]}
	soft_util=${cpu_util[4]}
	cpu_idle=${cpu_util[5]}
	echo >> $tmpfile
	echo "D state task: $dsleep_tasks" >> $tmpfile
	echo "running task: $running_tasks" >> $tmpfile
	echo "####################################################################################" >> $tmpfile
}

create_logfile() {
	if [ -f "$lockfile" ]; then
		kill -9 `cat $lockfile`
		rm -f $lockfile
	fi
	echo $$ > $lockfile
}

output_dir=/tmp
lockfile=${output_dir}/loadrecord.lock
tmpfile=${output_dir}/tmp.log
interval=5
running_tasks=0
dsleep_tasks=0

while getopts 'i:h' OPT; do
	case $OPT in
		"i")
			interval=$OPTARG
			;;
		"h")
			usage
			exit 0
			;;
		"*")
			usage
			exit -1
			;;
	esac
done

create_logfile
record_current_load
rm -fr $lockfile
cat $tmpfile
