#!/bin/bash

mkdir -p /tmp/lstopo/
rm /tmp/lstopo/*

ls -d /sys/devices/system/node/node*/ > /tmp/lstopo/data
NODE_MAX=0
while read DIR;do
	NODE_CPUS[$NODE_MAX]=$(cat $DIR/cpulist)
	NODE_MAX=$(($NODE_MAX+1))
done < /tmp/lstopo/data

ls -d /sys/devices/system/cpu/cpu[0-9]*/ > /tmp/lstopo/data
CPU_MAX=0
while read DIR;do
	CPU=`basename $DIR | cut -f2 -d'u'`
	NID=`ls $DIR | grep node[0-9] | cut -f2 -d'e'`
	CID=`cat $DIR/cache/index3/id`

	L3_CPUS[$CID]+="$CPU "
	echo "$CPU" >> /tmp/lstopo/NODE$NID:$CID

	CPU_MAX=$(($CPU_MAX+1))
done < /tmp/lstopo/data

for ID in "${!NODE_CPUS[@]}";do
	echo "NODE${ID}: ${NODE_CPUS[$ID]}"
done

ls /tmp/lstopo/NODE* | while read F;do
	echo `basename $F`: `sort -n $F`
done
